#!/usr/bin/perl

############################################################
# E-Blah Bulliten Board Systems ---------- Setup Subsystem #
############################################################
# Software Version : Platinum Setup -- Version 1.6         #
# Setup Project    : May 2005 by Justin <justin@eblah.com> #
# Distrobuted by   : http://www.eblah.com                  #
# License Agreement: http://www.eblah.com/license.php      #
############################################################
#   Copyright (c) 2005 E-Blah!                             #
############################################################

# Global version information:
$eblahsetupv = $coreversion = 2;
$version     = 'Platinum 9.7';
$scriptname  = 'Setup.pl';
$blahname    = 'Blah.pl';
$interals    = 'Setup97';

# Once you have a working install, you can comment this out so that it will not require the CGI module
use CGI::Carp 'fatalsToBrowser';
use Fcntl ':flock';

UFS();
$copyright = qq~Copyright &#169; 2001-2006 <a href="http://www.eblah.com" target="_blank">E-Blah</a>.~;

if(!SetupLoad('Settings.pl',1) || !SetupLoad("$code/QuickCore.pl",1)) { InstallConfig(); }

$languagep = "English";

$language = "$languages/$languagep";

{
	# Upgrade lock clear ...
	if(!-e("$messages/Mail/database.mail")) { unlink("$prefs/Setup.lock"); } # This forum will be upgraded to P9.2

	if(-e("$prefs/$interals.lock") && $URL{'step'} ne '3') { error("This forum has already been installed, please remove the $scriptname file from your server."); }
		elsif($URL{'step'} eq '3') { Step3(); }

	if($URL{'lowlevel'}) { InstallConfig(); }

	if($URL{'a'} && $URL{'step'} eq '1') { Step1U(); }
	elsif($URL{'step'} eq '1') { Step1(); }
	elsif($URL{'step'} eq '2') { Step2(); }
		else { Welcome(); }
}

sub InstallConfig {
	if($URL{'page'} == 2) {
		if(!-e("$FORM{'root'}") || !-e("$FORM{'blahdocs'}")) { error("One or more of the directories you provided could not be found."); }

		# Things went well with the install ...
		chmod 0777, "$FORM{'root'}/Setup.pl","$FORM{'root'}/Settings.pl","$FORM{'root'}/Blah.pl";

		open(FILE,"$FORM{'root'}/Setup.pl");
		@setupdump = <FILE>;
		close(FILE);
		chomp @setupdump;

		open(FILE,">$FORM{'root'}/Setup.pl");
		foreach $temp (@setupdump) {
			$temp =~ s/\'Settings.pl\'/"$FORM{'root'}\/Settings.pl"/g;
			print FILE "$temp\n";
		}
		close(FILE);

		open(FILE,"$FORM{'root'}/Blah.pl");
		@setupdump = <FILE>;
		close(FILE);
		chomp @setupdump;

		open(FILE,">$FORM{'root'}/Blah.pl");
		foreach $temp (@setupdump) {
			$temp =~ s/\'Settings.pl\'/\'$FORM{'root'}\/Settings.pl\'/g;
			print FILE "$temp\n";
		}
		close(FILE);

		open(FILE,"$FORM{'root'}/Settings.pl");
		@setupdump = <FILE>;
		close(FILE);
		chomp @setupdump;

		open(FILE,">$FORM{'root'}/Settings.pl");
		foreach $temp (@setupdump) {
			$temp =~ s/\".\"/\"$FORM{'root'}\"/g;
			$temp =~ s/\"\$ENV\{\'DOCUMENT_ROOT\'\}\/blahdocs\"/\'$FORM{'blahdocs'}\'/g;
			print FILE "$temp\n";
		}
		close(FILE);

		chmod 0755, "$FORM{'root'}/Setup.pl","$FORM{'root'}/Blah.pl";
		chmod 0666, "$FORM{'root'}/Settings.pl";

		header('Installation Configuration Complete');
		print <<"EOT";
<blockquote><br>
Setup has been sucessfully configured to run on your server. To continue Setup <a href="$scriptname">click here</a>.
</blockquote>
EOT
		footer();
		exit;
	}

	# $ENV{'DOCUMENT_ROOT'}<br><b>Script name:</b> $0
	$fulldir = $0;
	$fulldir =~ s/\\/\//g;
	$ENV{'DOCUMENT_ROOT'} =~ s/\\/\//g;
	if($fulldir eq $scriptname) { $fulldir = "$ENV{'DOCUMENT_ROOT'}/cgi-bin/forum"; }
		else { $fulldir =~ s/\/$scriptname//g; }

	if(-e("$root")) { $rootdir = $root; $correct{'root'} = 1; }
	elsif(-e("$fulldir")) { $rootdir = $fulldir; $correct{'root'} = 1; }
		else {
			$rootdir ="./";
			if(-e("$rootdir")) { $correct{'root'} = 1; }
		}
	if(-e("$tempdirectory")) { $bdocsdir = $tempdirectory; $correct{'bdocs'} = 1; }
	elsif(-e("$ENV{'DOCUMENT_ROOT'}/public_html/blahdocs")) { $bdocsdir = "$ENV{'DOCUMENT_ROOT'}/public_html/blahdocs"; $correct{'bdocs'} = 1; }
		else {
			$bdocsdir ="$ENV{'DOCUMENT_ROOT'}/blahdocs";
			if(-e("$bdocsdir")) { $correct{'bdocs'} = 1; }
		}

	$correct{'root'} = $correct{'root'} ? '<font color="green">Found (Correct)</font>' : '<font color="red">Not Found (Incorrect)</font>';
	$correct{'bdocs'} = $correct{'bdocs'} ? '<font color="green">Found (Correct)</font>' : '<font color="red">Not Found (Incorrect)</font>';

	header('Installation Configuration');
	print <<"EOT";
     <div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Introduction</b></div><br>
<blockquote>Either setup could not find a directory or you were redirected here when attempting to install your forum.<br><br>
Setup has <i>attempted</i> to locate your directories based on information your server is providing Perl. If these settings are correct, it is safe to continue with setup. Settings.pl MUST be located in the "root" directory.<br><br>
The information supplied is not all of the directories you are able to configure in E-Blah; therefore, if you are still having problems after saving you may need to <i>manually</i> edit Settings.pl or <a href="http://www.eblah.com/forum/">contact E-Blah technical support</a>.<br><br>
For support reasons, the following file was not found: $tempreturn</blockquote>
     <div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Directory Settings</b></div><br>
      <table align="center" width="502" cellpadding="4">
       <form action="$scriptname?lowlevel-1/page-2/" method="post"><tr>
        <td width="250" valign="top"><b>Root Directory:</b></td>
        <td width="250"><input type="text" name="root" value="$rootdir" class="textinput" size="50"><br>$correct{'root'}</td>
       </tr><tr>
        <td width="250" valign="top"><b>Blahdocs Directory:</b></td>
        <td width="250"><input type="text" name="blahdocs" value="$bdocsdir" class="textinput" size="50"><br>$correct{'bdocs'}</td>
       </tr><tr>
        <td colspan="2" align="center"><div width="100%" style="padding: 5px;"><input type="submit" value="     Check Paths and Continue     " class="button"></div></td>
       </tr></form>
      </table>
EOT
	footer();
	exit;
}

sub SetupLoad {
	eval { require($_[0]) };
	if($@) {
		if($_[1]) { $tempreturn = $_[0]; return(0); }
		error(qq~Fatal Error in loading: $_[0]<br><br>$@~);
	} else { return(1); }
}

sub UFS {
	my($query);
	@url = split(/\//,$ENV{'QUERY_STRING'});
	foreach (@url) {
		($action,$actiondo) = split(/-/,$_);
		$URL{$action} = $actiondo;
	}
	read(STDIN, my $temp, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/,$temp);

	foreach (@pairs) {
		($key,$content) = split(/=/,$_);
		$content =~ tr/+/ /;
		$content =~ s/%(..)/pack("c",hex($1))/ge;
		$key =~ tr/+/ /;
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		chomp($content);
		$FORM{$key} = $content;
	}
}

sub error {
	header('Fatal Error');
	print <<"EOT";
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>There was an error installing or upgrading your forum ...</b></div>
<blockquote>$_[0]</blockquote>
EOT
	footer();
}

# This isn't needed, but is called by Themes.pl when loaded
sub CoreLoad { 1; }

sub Welcome {
	$section = 1;
	header('Welcome to E-Blah');
	print <<"EOT";
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Welcome to the E-Blah Install / Upgrade Script</b></div>
<blockquote><div align="justify">Welcome to the Platinum 9 series of E-Blah! We are very pleased that you have chosen E-Blah as your forum software, and hope that you will enjoy it for years to come!
<br><br>
This script will install (or upgrade) your forum to the latest E-Blah Platinum 9 series (Version 9.3). If you are new to E-Blah, this script will help you with your first time installation. If you are upgrading a Platinum 8 or 9 series forum, you will enjoy how easy this upgrade will be.  If you are using a forum older than this (prior to Platinum 8), please <a href="http://www.eblah.com/forum/m-1107906919/">click here</a>. This installation should only take a few minutes of your time, and you will then be able to configuring your forum and then on your way to creating a community!
<br><br>
Before you continue, please make sure you have read the pre-installation instructions carefully (Readme.html in the main package).
</div></blockquote>
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Important Release Notes</b></div>
<blockquote><div align="justify"><b>Apache mod_rewrite</b> &nbsp; This, and future versions of E-Blah, can be modified to allow for Apache mod_rewrite, which will both help your sites pagerank and will also allow for easier managing of your forum. To view more information on this new feature <a href="http://www.eblah.com/forum/m-1125974489/">click here</a>. For more information about ways to make your forum bot friendly view <a href="http://www.eblah.com/forum/m-1126465358/">this page</a> and <a href="http://www.eblah.com/forum/m-1126579116/">this page</a>.<br><br>
<b>MD5 Password Encryption Migration</b> &nbsp; Forum admins can now change from the Perl crypt() encryption, which isn't very powerful, to MD5 encryption, which is very powerful. Members will be asked to change their password on each page of the forum until they change it to update to the new MD5 format.<br><br>
<b>Security Updates</b> &nbsp; In terms of security, E-Blah has been updated tremendously.  Of the new features is the ability to assign each board a level at which members can do certain things.  If you are performing a new install of E-Blah, then you'll find these features of great importance.  If you are upgrading you'll need to make sure setup has upgraded EACH board's permissions correctly.  In most cases it will, but there are some rare occasions where it will not.</blockquote>
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Setup Options</b></div>
<blockquote><center><b><a href="$scriptname?step-1/a-upgrade/">Upgrade Current Forum</a><br><br>
<a href="$scriptname?step-1/">Install a New Forum</a></b></center></blockquote>
EOT
	footer();
}

sub is_admin { return(1); }

sub Step1U {
	# To be safe, we're going to chmod the current directories so that no problems come up.
	chmod 0777, $prefs,$boards,$members,$messages,$boards,$uploaddir,$templates;
	chmod 0666, "$root/Settings.pl";
	$converted = '';

	# New Permissions Setup ........... (needs finishing)
		{
			fopen(FILE,"$boards/bdindex.db");
			@file = <FILE>;
			fclose(FILE);
			chomp @file;
			$newfile = '';
			foreach(@file) {
				$mgroups = '';
				($t1,$t2,$t3,$t4,$t5,$t6,$t7,$t8,$t9,$t10,$mgroups2,$t12,$t13,$t14,$t15) = split('/',$_);
				if($t5 eq '') { $t5 = 'guest,validating,member'; }
				if($t6 eq '') { $t6 = 'guest,validating,member'; }
				if(!$t7) { $t7 = 'guest,validating,member'; } else { $t7 = ''; }
				if(!$t13) { $t13 = 'guest,validating,member'; } else { $t13 = ''; }
				if($mgroups2 eq '') { $mgroups2 = 'guest,validating,member'; }
				$mgroups =~ s/,\Z//g;
				$newfile .= "$t1/$t2/$t3/$t4/$t5/$t6/$t7/$t8/$t9/$t10/$mgroups2/$t12/$t13/$t14/$t15/guest,validating,member\n";
			}
			fopen(FILE,">$boards/bdindex.db");
			print FILE $newfile;
			fclose(FILE);

			fopen(FILE,"$boards/bdscats.db");
			@file = <FILE>;
			fclose(FILE);
			chomp @file;
			$newfile = '';
			foreach(@file) {
				$mgroups = '';
				($t1,$t2,$mgroups2,$t4,$t5,$t6) = split(/\|/,$_);
				if($mgroups2 eq '') { $mgroups2 = 'guest,validating,member'; }
				$newfile .= "$t1|$t2|$mgroups2|$t4|$t5|$t6\n";
			}
			fopen(FILE,">$boards/bdscats.db");
			print FILE $newfile;
			fclose(FILE);

			$converted .= "<li>Rebuilt permissions ...</li>";
		}

	# P9.3/5 Updates
	fopen(FILE,"$members/List.txt");
	@memlist = <FILE>;
	fclose(FILE);
	chomp @memlist;
	foreach $memname (@memlist) {
		if($memname =~ /-/) {
			$memname1 = $memname;
			$memname =~ s/-/_/g;
			if(-e("$members/$memname.dat")) { $memname .= time; }

			rename("$members/$memname1.dat","$members/$memname.dat");
			rename("$members/$memname1.vlog","$members/$memname.vlog");
			rename("$members/$memname1.lo","$members/$memname.lo");
			rename("$members/$memname1.log","$members/$memname.log");
			rename("$members/$memname1.pm","$members/$memname.pm");
			rename("$members/$memname1.prefs","$members/$memname.prefs");
			rename("$members/$memname1.msg","$members/$memname.msg");
		}
	}
	$URL{'v'} = 'memberpanel';
	require("$code/Admin1.pl");
	require("$code/Load.pl");
	Remem();
	$converted .= "<li>Rebuilt the members list ...</li>";

	# P9.2 Updates
	if(!-e("$messages/Mail/database.mail") && -e("$prefs/Ranks2.txt")) {
		# P9.2 Upgrades ...
		opendir(DIR,"$messages/Mail/");
		while($show = readdir(DIR)) {
			if($show =~ /\.mail/) { push(@messages,$show); }
		}
		closedir(DIR);
		fopen(DB,">$messages/Mail/database.mail");
		foreach(@messages) {
			fopen(FILE,"$messages/Mail/$_");
			@file = <FILE>;
			fclose(FILE);
			chomp @file;
			$strang = '';
			foreach $junks (@file) {
				$strang .= "$junks,";
			}
			unlink("$messages/Mail/$_");

			$crao = $_;
			$crao =~ s/\.mail\Z//g;
			$strang =~ s/,\Z//g;
			if($strang eq '') { next; }
			print DB "$crao|$strang\n";
		}
		fclose(DB);

		$converted .= "<li>Rebuilt the mail database ...</li>";
	}

	# Pre-P9 upgrades
	if(!-e("$prefs/Ranks2.txt")) { # This ONLY checks for this file, may cause issues with alpha upgraders ... haha ...
		use File::Copy;
		if(!-e("$prefs/ThemesList.txt")) {
			mkdir("$templates/convert",0777);
			fopen(FILE,">$templates/convert/theme.dat");
			print FILE "name = 'Converted Theme'";
			fclose(FILE);

			copy("$templates/template.html","$templates/convert/template.html");
			copy("$templates/template.css","$templates/convert/template.css");
			copy("$templates/admintemplate.css","$templates/convert/admintemplate.css");
			copy("$templates/Smilies.html","$templates/convert/Smilies.html");
		}
		if(!-e("$messages/Mail")) {
			mkdir("$messages/Mail/",0777);

			opendir(DIR,"$messages");
			while($show = readdir(DIR)) {
				if($show =~ /\.mail/) { copy("$messages/$_","$messages/Mail/$_"); }
			}
			closedir(DIR);

			opendir(DIR,"$messages/Mail/");
			while($show = readdir(DIR)) {
				if($show =~ /\.mail/) { push(@messages,$show); }
			}
			closedir(DIR);
			fopen(DB,">$messages/Mail/database.mail");
			foreach(@messages) {
				fopen(FILE,"$messages/Mail/$_");
				@file = <FILE>;
				fclose(FILE);
				chomp @file;
				$strang = '';
				foreach $junks (@file) {
					$strang .= "$junks,";
				}
				unlink("$messages/Mail/$_");

				$crao = $_;
				$crao =~ s/\.mail\Z//g;
				$strang =~ s/,\Z//g;
				if($strang eq '') { next; }
				print DB "$crao|$strang\n";
			}
			fclose(DB);
		}
		if(!-e("$prefs/Ranks2.txt")) {
			$converted .= "<li>Converted Member Group permissions to version 2 (Ranks.txt file deleted) ...</li>";
			$converted .= "<li>Cleaned up previous member group settings from member files ...</li>";

			fopen(FILE,"$prefs/Ranks.txt") || error("Could not find the old member group permissions! This forum may have already been upgraded, or has not yet been installed.");
			@ranks = <FILE>;
			fclose(FILE);
			chomp @ranks;

			foreach(@ranks) {
				($name,$reparse) = split(/\|/,$_);
				($t,$t,$t,$t,$t,$t,$t,$t,$t,$admin) = split(',',$reparse);
				$admingrp{$name} = $admin;
			}

			$counter = 0;

			fopen(FILE,"$members/List.txt");
			@list = <FILE>;
			fclose(FILE);
			chomp @list;

			foreach $open (@list) {
				fopen(FILE2,"$members/$open.dat");
				@trash = <FILE2>;
				fclose(FILE);
				chomp @trash;

				fopen(FILE2,">$members/$open.dat");
				foreach(@trash) {
					++$counter;
					if($counter == 5) { # Clear the old member group ;)
						if($admingrp{$_}) { $grp = 'Administrator'; }
							else { $grp = $_; }
						$members{$_} .= "$open,";
						print FILE2 "\n";
						next;
					}
					print FILE2 "$_\n";
				}
				fclose(FILE2);
				$counter = 0;
			}

			$count2 = 0;
			foreach(@ranks) {
				++$counter;
				($name,$reparse) = split(/\|/,$_);
				if($counter == 1) {
					($color,$star,$starcount) = split(',',$reparse);
					$members{'Administrator'} =~ s/,\Z//g;
					$newfile = <<"EOT";
Administrator => {
name = '$name'
star = '$star'
starcount = '$starcount'
team = '1'
color = '$color'
level = '1'
manager = ($members{'Administrator'})
members = ($members{'Administrator'})
}\n
EOT
					$newgroup{'Administrator'} = 'Administrator';
				} elsif($counter == 7) {
					($team,$star,$starcount) = split(',',$reparse);
					$newfile .= <<"EOT";
Moderators => {
name = '$name'
star = '$star'
starcount = '$starcount'
team = '$team'
level = '1'
}\n
EOT
				} else {
					($ip,$mod,$st,$m,$pro,$star,$team,$color,$cal,$admin,$count,$starcount) = split(',',$reparse);
					++$count2;

					if($count eq '' && $counter < 7) { next; } # These groups were disabled.

					$newfile .= "$count2 => {\n";
					$name2 = $name;
					$name =~ s/\'/&#8217;/g;

					$newfile .= "name = '$name'\n";
					$newfile .= $color ? "color = '$color'\n" : '';
					$newfile .= $team ? "team = '$team'\n" : '';

					$newfile .= $star ? "star = '$star'\n" : '';
					$newfile .= $starcount ? "starcount = '$starcount'\n" : '';
					$newfile .= $count ? "pcount = '$count'\n" : '';

					# Permissions
					if($counter > 7) {
						$newgroup{$name} = $count2;
						$newfile .= $ip ? "ip = '$ip'\n" : '';
						$newfile .= $mod ? "moderate = '$mod'\n" : '';
						$newfile .= $st ? "sticky = '$st'\n" : '';
						$newfile .= $m ? "modify = '$m'\n" : '';
						$newfile .= $pro ? "profile = '$pro'\n" : '';
						$newfile .= $cal ? "cal = '$cal'\n" : '';
					}

					# Finish group setup with members allowed
					if($count eq '') {
						$newfile .= "level = '1'\n";

						$members{$name2} =~ s/,\Z//g;
						$newfile .= "manager = ()\n";
						$newfile .= "members = ($members{$name2})\n";
					}
					$newfile .= "}\n\n";
				}
			}

			fopen(FILE,">$prefs/Ranks2.txt");
			print FILE $newfile;
			fclose(FILE);

			fopen(FILE,"$boards/bdindex.db");
			@file = <FILE>;
			fclose(FILE);
			chomp @file;
			$newfile = '';
			foreach(@file) {
				$mgroups = '';
				($t1,$t2,$t3,$t4,$t5,$t6,$t7,$t8,$t9,$t10,$mgroups2,$t12,$t13,$t14) = split('/',$_);
				foreach(split(',',$mgroups2)) { $mgroups .= "$newgroup{$_},"; }
				$mgroups =~ s/,\Z//g;
				$newfile .= "$t1/$t2/$t3/$t4///$t7/$t8/$t9/$t10/$mgroups/$t12/$t13/$t14\n";
			}
			fopen(FILE,">$boards/bdindex.db");
			print FILE $newfile;
			fclose(FILE);

			fopen(FILE,"$boards/bdscats.db");
			@file = <FILE>;
			fclose(FILE);
			chomp @file;
			$newfile = '';
			foreach(@file) {
				$mgroups = '';
				($t1,$t2,$mgroups2,$t4,$t5,$t6) = split(/\|/,$_);
				foreach(split(',',$mgroups2)) { $mgroups .= "$newgroup{$_},"; }
				$mgroups =~ s/,\Z//g;
				$newfile .= "$t1|$t2|$mgroups|$t4|$t5|$t6\n";
			}
			fopen(FILE,">$boards/bdscats.db");
			print FILE $newfile;
			fclose(FILE);

			unlink("$prefs/Ranks.txt");
			$converted .= "<li>Boards Database rebuilt ...</li>";
		}

		# Search for converted theme(s)
		require("$code/Themes.pl");
		ThemeResearch();
		$converted .= "<li>Convert old default template to new format ...</li>";
		$convertness = "<b>PLEASE NOTE</b> that some board permissions <i>may</i> have been reset (as the upgrade changed the way these worked), <b>PLEASE</b> review these changes in the Admin center!<br><br>";
	}

	fopen(FILE,">$prefs/Setup95.lock");
	print FILE "1";
	fclose(FILE);
	$converted .= "<li>Locked Setup from being run again ...</li>";

	$section = 2;
	header('Convert Files');
	print <<"EOT";
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Forum Conversion Statistics ...</b></div>
<ul>$converted</ul>
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Upgrade Finished</b></div>
<blockquote>This forum has been upgrade successfully.<br><br><b>DO NOT</b> attempt to run this upgrade script again!<br><br>$convertness<center><b><a href="$scriptname?step-3/a-upgrade/">Delete Setup Files and go to Your Forum</a></b></center></blockquote>
EOT
	footer();
	exit;
}

sub Step1 {
	$nodir .= "<li><span style=\"width: 150px\">Prefs</span><b> Currently set to:</b> $prefs</li>" if(!-e("$prefs"));
	$nodir .= "<li><span style=\"width: 150px\">Messages</span><b> Currently set to:</b> $messages</li>" if(!-e("$messages"));
	$nodir .= "<li><span style=\"width: 150px\">Members</span><b> Currently set to:</b> $members</li>" if(!-e("$members"));
	$nodir .= "<li><span style=\"width: 150px\">Boards</span><b> Currently set to:</b> $boards</li>" if(!-e("$boards"));
	$nodir .= "<li><span style=\"width: 150px\">Languages</span><b> Currently set to:</b> $languages</li>" if(!-e("$languages"));
	$nodir .= "<li><span style=\"width: 150px\">Avatars</span><b> Currently set to:</b> $avdir</li>" if(!-e("$avdir"));
	$nodir .= "<li><span style=\"width: 150px\">uploads</span><b> Currently set to:</b> $uploaddir</li>" if(!-e("$uploaddir"));
	$nodir .= "<li><span style=\"width: 150px\">template</span><b> Currently set to:</b> $templates</li>" if(!-e("$templates"));

	if($nodir) {
		$nodir =~ s/, \Z//g;
		$nodir = <<"EOT";
<div style="background-color: #FFF5F5; padding: 5px; border: 1px solid #293B2A;">
<font color="red" size="4"><b>WARNING!</b></font><font color="red"><br>
Your forum <i>may</i> not work properly if you continue. Setup recommends <a href="$scriptname?lowlevel-1/">using this page</a> to edit the paths that cause these problems with your forum. If all else fails Setup recommends editing the path to directories in Settings.pl and then refreshing this page until this message disappears. There was a problem verifying that the following directories exist:<br>
<ul>$nodir</ul>The following may help you figure out what your paths are:
<blockquote><b>Document Root:</b> $ENV{'DOCUMENT_ROOT'}<br><b>Script name:</b> $0</blockquote>
Please note that not <i>all</i> server report the above information.<br><br>
You are advised to use <a href="$scriptname?lowlevel-1/">this tool</a> to try to solve your directory problems.<br><br>
<b>For the quickest support on the <a href="http://www.eblah.com/forum/">E-Blah Support Forum</a>, PLEASE copy and past <i>everything</i> in this red box.</b></font>
EOT
		$fataldie = qq~<font color="red"><b>Your install may not work or complete correctly (see error above).</b></font><br><br>~;
	} else { $nodir = qq~<div style="background-color: #DEE8DF; padding: 5px; border: 1px solid #293B2A;"><font color="#293B2A" size="4"><b>Success!</b></font><br><font color="#293B2A">Setup has verified that all the directories appear to exist on the server (they may not be writeable though). Setup will <i>attempt</i> to chmod these directories before continuing (to make them writeable). However, it is recommended that you chmod the directories and files as shown in the install documentation before continuing. Again, setup will <i>attempt</i> to chmod these directories for you; <b>however</b>, there is no guarantee that it will work.</font>~; }

	if(-e("$prefs/Ranks.txt")) { error('This forum needs to be upgraded, not installed.'); }
	if(-e("$prefs/Ranks2.txt")) { error('This forum appears to have already been installed.'); }

	$section = 2;
	header('Administrator Information');
	print <<"EOT";
     <div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Administrator Information</b></div><br>
      <blockquote>$nodir</div><br>Setup needs the following information before it can continue ...</blockquote>
      <table align="center" width="502">
       <form action="$scriptname?step-2/" method="post"><tr>
        <td width="250"><b>Forum Name:</b></td>
        <td width="250"><input type="text" name="forumname" value="$ENV{SERVER_NAME} Forum" class="textinput"></td>
       </tr><tr>
        <td width="250"><b>Forum Cookie Prefix:</b></td>
        <td width="250"><input type="text" name="cookpre" value="eblah" class="textinput"></td>
       </tr><tr>
        <td><b>Administrator screen name:</b></td>
        <td><input type="text" name="screenname" value="Administrator" size="30" class="textinput"></td>
       </tr>
        <td colspan="2" class="smalltext">Please note that you can use 'admin' <b>or</b> the screen name you enter here to login to the forums after setup has been completed.<br><br></td>
       </tr><tr>
        <td width="250"><b>Password:</b></td>
        <td width="250"><input type="password" name="pw" value="admin" maxlength="8" class="textinput"></td>
       </tr><tr>
        <td><b>Password (confirm):</b></td>
        <td><input type="password" name="cpw" value="admin" maxlength="8" class="textinput"></td>
       </tr><tr>
        <td colspan="2" class="smalltext" align="center"><br>The default password is <b>admin</b>.<br><br></td>
       </tr><tr>
        <td><b>Administrator e-mail address:</b></td>
        <td><input type="text" name="email" value="admin\@mysite.com" size="30" class="textinput"></td>
       </tr><tr>
        <td colspan="2" align="center"><div width="100%" style="padding: 5px;"><br>$fataldie<input type="submit" value="     Save and Finish Install     " class="button"></div></td>
       </tr></form>
      </table>
     <div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Saving ...</b></div><br>
<blockquote>After you click "Save and Finish Install", e-blah will be installed and files will be copied onto your server by this Setup script. Please only click the button <b>once</b>. The setup should take only a few seconds, and after which you will be able to access your forum.</blockquote>
EOT
	footer();
}

sub Step2 {
	if(-e("$prefs/Ranks.txt")) { error('This forum needs to be upgraded, not installed.'); }
	if(-e("$prefs/Ranks2.txt")) { error('This forum appears to have already been installed.'); }

	error("Invalid information in form submitted") if($FORM{'screenname'} !~ /\A[0-9A-Za-z%+,-\.@^_ &nbsp;]+\Z/ || $FORM{'screenname'} eq '' || length($FORM{'screenname'}) > 30);
	error("Invalid information in form submitted") if($FORM{'pw'} eq '' || length($FORM{'pw'}) > 8);
	error("Invalid information in form submitted") if($FORM{'cpw'} eq '');
	error("Invalid information in form submitted") if($FORM{'email'} eq '' || length($FORM{'email'}) > 60 || $FORM{'email'} !~ /\A([0-9A-Za-z\._\-]{1,})@([0-9A-Za-z\._\-]{1,})+\.([0-9A-Za-z\._\-]{1,})+\Z/);
	error("Invalid information in form submitted") if($FORM{'cpw'} ne $FORM{'pw'});

	$email = lc($FORM{'email'});

	@prefslist   = ('.htaccess','Active.txt','AdminLog.txt','Attachments.txt','BMail.txt','Censor.txt','ClickLog.txt','Events.txt','IpLog.txt','ips.txt','MaxLog.txt','News.html','News.txt','Ranks2.txt','Refer.txt','ReportPM.txt','RTemp.txt','Sids.sid','smiley.txt','Smilies.html','ThemesList.txt');
	@boardslist  = ('.htaccess','bdindex.db','bdscats.db','cc.msg','cc.ino','Stick.txt');
	@memberslist = ('.htaccess','admin.dat','admin.log','LastMem.txt','List.txt','List2.txt');
	# Get the list of files to write to durring install ...
	WriteFiles();

	# Chmod the directories ...
	chmod 0777, $prefs,$boards,$members,$messages,$boards,$uploaddir,$templates;
	chmod 0666, "$root/Settings.pl";
	chmod 0755, "$root/Blah.pl"; # This might help some people ...

	foreach(@prefslist) {
		fopen(FILE,">$prefs/$_") || error('Cannot write to /Prefs, please check your Settings.pl file and try again.');
		print FILE $files{"$_"};
		fclose(FILE);
	}
	foreach(@boardslist) {
		fopen(FILE,">$boards/$_") || error('Cannot write to /Boards, please check your Settings.pl file and try again.');
		print FILE $files{"$_"};
		fclose(FILE);
	}
	foreach(@memberslist) {
		fopen(FILE,">$members/$_") || error('Cannot write to /Members, please check your Settings.pl file and try again.');
		print FILE $files{"$_"};
		fclose(FILE);
	}

	fopen(SETTINGS,">$root/Settings.pl");
	$savesettings = <<"EOT";
####################################################
# E-Blah Bulliten Board Systems           Platinum #
####################################################
# This file was created by the setup.  You should  #
# look at ALL the settings in Admin Center         #
# YOU SHOULD NEVER EDIT THIS FILE BY HAND          #
####################################################

\$bversion = 2;      # POST-SETUP Version

####### Directories Sets #######
\$root = "$root";
\$code = "$code";
\$boards = "$boards";
\$prefs = "$prefs";
\$members = "$members";
\$messages = "$messages";
\$images = "$images";
\$buttons = "$buttons";
\$simages = "$simages";
\$avsurl = "$avsurl";
\$avdir = "$avdir";
\$realurl = "$realurl";
\$bdocsdir = "$bdocsdir";
\$languages = "$languages";
\$templates = "$templates";
\$templatesu = "$templatesu";
\$modsdir = "$modsdir";

#######  Essential Sets  #######
\$regto = qq*$FORM{'screenname'}*;
\$eadmin = q*$email*;
\$cookpre = qq*$FORM{'cookpre'}*;
\$mailuse = 1;
\$smaill = "/usr/sbin/sendmail";
\$emailsig = q*This e-mail was sent via eblah.&nbsp; It is not in any way related to eblah or eblah.com.*;

#######   Board Locks    #######
\$maintancer = qq~This board is being upgraded.~;

#######   Upload Prefs   #######
\$uploaddir = "$uploaddir";
\$uploadurl = "$uploadurl";
\$maxsize = "1";
\$maxsize2 = ".25";

#######    Main Prefs    #######
\$upbc = 1;
\$noguestp = 1;
\$al = 1;
\$whereis = 1;
\$showmove = 1;
\$apic = 1;
\$hmail = 1;
\$slpoller = 1;
\$BCSmile = 1;
\$BCLoad = 1;
\$showreg = 1;
\$maxsig = "500";
\$maxmess = 15;
\$maxdis = 30;
\$mbname = q*$FORM{'forumname'}*;
\$picheight = "100";
\$picwidth = "100";
\$btod = 1;
\$amar = 1;
\$sauser = 1;
\$mmpp = 25;
\$iptimeout = 5;
\$vhtdmax = 50;
\$htdmax = 25;
\$totalpp = 10;
\$showdes = 1;
\$showtheme = 1;
\$sview = 1;
\$showactive = 1;
\$logactive = 1;
\$reversesum = 1;
\$languagep = "English";
\$nocomma = ',';
\$polltop = 1;
\$pollops = "7";
\$quickreply = 1;
\$gmaxsmils = 200;
\$maxmesslth = 50000;
\$maxsumc = "40";
\$upevents = 7;

#######     Logging      #######
\$eclick = 1;
\$uextlog = 1;
\$kelog = 1;
\$logip = 1;
\$logcnt = "60";
\$logdays = 365;
\$activeuserslog = 15;

#######       News       #######
\$newsshow = 5;
\$newslength = 200;
EOT
	$savesettings =~ s~\\~/~sig; # Get rid of x:\ with Win32 systems
	print SETTINGS $savesettings;
	fclose(SETTINGS);

	fopen(FILE,">$prefs/Setup95.lock");
	print FILE "1";
	fclose(FILE);

	# Search for themes
	require("$code/Themes.pl");
	ThemeResearch();

	header('Copy Files');
	print <<"EOT";
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>File Copy Status</b></div>
<ul>
<li>Prepare the member data entered previously ...</li>
<li>Create the databases, and prepare to write them to file ...</li>
<li>Copy files to the directories ...</li>
<li>Locked the Setup file ...</li>
</ul>
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Install Complete</b></div>
<blockquote>This forum has been installed successfully.<br><br><b>DO NOT</b> attempt to run this install script again!<br><br><center><b><a href="$scriptname?step-3/a-upgrade/">Delete Setup Files and go to Your Forum</a></b></center></blockquote>
EOT
	footer();
}

sub Step3 {
	chmod 0777, "$root/$scriptname";
	unlink("$root/$scriptname") || error('Could not remove setup files from the server. Please remove Setup.pl manually.');
	header('Setup Complete');
	print <<"EOT";
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Remove Successfull ...</b></div>
<blockquote>$scriptname has been removed from the server. It is recommended that you refresh this page to ensure it was, indeed, deleted successfully.  If it was not, you should remove it via FTP before using your forum.</blockquote>
<div width="100%" class="win2" style="padding: 5px; font-variant: small-caps;"><b>Your Forum</b></div>
<blockquote><center><a href="./$blahname">Go to your Forum</a></center></blockquote>
EOT
	footer();
}

sub header {
	($title) = $_[0];

	print "Content-type: text/html\n\n";
	print <<"EOT";
<html>

<head>
<STYLE type="text/css">
/* Global Table Settings */

body, table, td {

	font-family: Verdana;

	font-size  : 11px;

	color      : #1D1F22;

}



/* The forum background color */

.mainbg { background-color: #F1F1F1; }



/* Colors */

.titlebg {

	background-color: #E1E5EB;

	font-family     : Verdana, Helvetica;

	font-size       : 12px;

	color           : #000000;

	font-weight     : bold;

}



.catbg {

	background-color: #E1E1E1;

	font-family     : Verdana, Helvetica;

	font-size       : 12px;

	color           : #000000;

	font-weight     : bold;

}



.win       { background-color: #F4F4F4; }

.win2      { background-color: #EDEDED; }

.border    { background-color: #B8B8B8; }



.smalltext { /* Small font text size, can also change color, etc */

	font-weight: normal;

	font-size  : 9px;

	line-height: 1.5;

}



.postbody { line-height: 1.5; } /* Format the post body */



/* Links */

a, a:link, a:active, a:visited {

	text-decoration: none;

	color          : #36383B;

	font-family    : Verdana, Helvetica;

	font-weight    : bold;

}



a:hover {

	text-decoration: none;

	color          : #1A1016;

	font-family    : Verdana, Helvetica;

	font-weight    : bold;

}

/* Forms */

.textinput,.button, select { /* .checkboxinput also allowed */

	color           : #000000;

	background-color: #EEEEEE;

	font-family     : Verdana, Helvetica, Times;

	font-size       : 10px;

	border          : 1px #8A8D96 solid;



	border-top-width   : 1px;

	border-right-width : 1px;

	border-bottom-width: 1px;

	border-left-width  : 1px;

}

.textinput {
	padding-top: 5px;
	padding-bottom: 5px;
	padding-left: 5px;
	padding-right: 5px;
	height: 25px;
	vertical-align: middle;
}

input { text-indent : 2px; }

input.button {
	border : 1px solid #000000;
	padding: 3px;
}

</STYLE>
<title>$title - E-Blah Install</title>
</head>

<body class="mainbg" topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0">
<div class="titlebg" style="padding: 5px; font-size: 18px;">$title</div>
<div class="win2" style="padding: 5px; border: 0px #B8B8B8 solid; border-bottom-width: 1px;">
<span style="float: left">$version</span>
<span style="float: right">E-Blah System Installer</span>&nbsp;
</div>


<table cellpadding="3" cellspacing="0" width="100%">

 <tr>
  <td><br>
   <table cellpadding="0" cellspacing="0" width="100%">
    <tr>
     <td valign="top" width="200">
      <table cellpadding="5" cellspacing="1" class="border" width="100%">
       <tr>
        <td class="titlebg" style="font-variant: small-caps;">Install Status</td>
       </tr><tr>
        <td class="win2">
<div class="win" style="padding: 5px;" align="center"><i>$title</i></div>
<ul>
<li>Welcome</li>
</ul>
<div class="win" style="padding: 5px;" align="center"><b>Upgrade Steps</b></div><br>
<ul>
<li>Convert Files</li>
<li>Delete Setup</li>
</ul>

<div class="win" style="padding: 5px;" align="center"><b>Install Steps</b></div><br>
<ul>
<li>Administrator Information</li>
<li>Copy Files</li>
<li>Delete Setup</li>
</li>
</ul></td>
       </tr>
      </table>
     </td>

     <td width="5">&nbsp;</td>
     <td valign="top">
      <table cellpadding="5" cellspacing="1" class="border" width="100%">
       <tr>
        <td class="titlebg" style="font-variant: small-caps;">$title</td>
       </tr><tr>
        <td class="win"><span class="postbody">
EOT
}

sub footer {
	print <<"EOT";
     </span></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
</td>

 </tr>

</table><br><font size="1">

<center>$copyright</center><br></font>

</body>

</html>
EOT
	exit;
}

sub WriteFiles {
	$time = time;

	# Prefs DIR
	$files{'Ranks2.txt'} = <<"EOT";
Administrator => {
name = 'Administrator Group'
level = '1'
star = 'stype2.gif'
starcount = '5'
color = 'red'
team = '1'
manager = (admin)
members = (admin)
}

Moderators => {
name = 'Board Moderator'
level = '1'
star = 'stype3.gif'
starcount = '5'
team = '1'
}

1 => {
name = 'Maximum Member'
star = '5star.gif'
starcount = '1'
pcount = '500'
}

2 => {
name = 'Big Member'
star = '4star.gif'
starcount = '1'
pcount = '200'
}

3 => {
name = 'Medium Member'
star = '3star.gif'
starcount = '1'
pcount = '100'
}

4 => {
name = 'Minimum Member'
star = '2star.gif'
starcount = '1'
pcount = '50'
}

5 => {
name = 'Baby Member'
star = '1star.gif'
starcount = '1'
pcount = '-1'
}
EOT
	$files{'Censor.txt'} = <<"EOT";
ass|a**
bitch|b****
fuck|f***
pussy|girl private
pussie|girl private
pussies|girls privates
vagina|girl private
dick|private
punkass|punka**
shit|mess
asshole|a**hole
fucker|f***er
nigger|black person
nigga|black person
dike|d**e
fag|f**
faggot|f*g**t
EOT
	$files{'News.html'} = <<"EOT";
<table cellpadding="4" cellspacing="1" width="100%" bgcolor="<blah v="$border">">

 <tr>

  <td bgcolor="<blah v="$win1">">

   <table cellpadding="0" cellspacing="0" width="100%">

    <tr>

     <td><font size="2"><b><img src="<blah v="$images">/<blah v="$micon">.gif"><a href="<blah v="$totalurl">"><blah v="$messtitle"></b></font></td>

     <td align="right"><font size="1"><blah v="$sdate"><br><blah v="$usertxt">: <blah v="$userpost"></font></td>

    </tr>

   </table>

  </td>

 </tr><tr>

  <td bgcolor="<blah v="$win2">"><font size="1"><blah v="$message"><hr color="<blah v="$border">" class="hr" size="1"><a href="<blah v="$totalurl">"><blah v="$commenttxt"></a> (<blah v="$replies">)</font></td>

 </tr>

</table><br>
EOT
	$files{'RTemp.txt'} = <<"EOT";
Although the moderators and administrator of this forum try their best to keep this forum free of any offensive content, there may be small, isolated incidents in which it is posted, and you as a user, accesses it. While we will try to remove such content before it is accessed by you or other users, it is impossible for us to keep track on each message posted on this forum at every moment of the day. If such content is posted, we will either edit or remove the post, and the appropriate action will be taken towards the user. You, therefore, acknowledge that all material posted on these forums express the views and opinions of the user which made the post and not the administrators, moderators, or system administrator (unless the posts are made by these people); therefore we cannot, and will not be held reliable for such content that is posted on these forums. <br><br>Upon registering, you agree to never use this forum for any vulgar, false, sexually oriented, threatening, obscene, abusive, hateful, slanderous, or anything that violates ANY acceptable laws; and you also agree to never hack, or attempt to hack into any area of this forum. You also agree never to post any copyrighted material, which you do not expressly own the copyright to, or that you do not have the authorization to use. Advertisements, spam (or useless information posted often), solicitation, and chain letters ARE NOT allowed on this forum. Failure to abide by these terms will subject your account to an immediate and permanent banning from our forum, and, depending on the severity of the incident, we may contact your internet service provider (ISP). For this reason, your IP address is logged each time you post a message, login or logout of the forum and each click is logged for a certain amount of time. This information will be expressly used to assist us if there are any attempts to hack into certain areas of this forum and may be used to contact your ISP upon breaking this agreement.<br><br>We agree to never sell or disclose any private information that you submit to us. Once you have successfully registered, you will be given a public profile, which allows everyone to see the various information that you submit to us; however, you are not required to disclose any of this information. You will be allowed to privatize certain information (such as your e-mail address), and you are not obligated to provide us with any personal information, which includes but is not limited to your gender, birth date, and name. While we agree never to sell any information, you provide to us, we will not be held responsible for any information that may be compromised by someone whom may hack into your account. It is highly recommended you use a password that is longer than six (6) characters and is a combination of letters and numbers. If your account has been hacked into, notify the system administrator immediately and we will look further into the matter, and adequate punishment will be given.<br><br>This forum system uses two methods of logging in, cookies and session identification (SID). If you use cookies to login, the forum will save your username, encrypted password, and board passwords to your computer in the form of a &quot;Cookie&quot;. The other method, session identification, will store your current session on this server using your IP address, username, encrypted password, and any board passwords you may use while using your session. If you use session identification, you will be logged out after three (3) hours of inactivity.<br><br>By clicking register below, you agree to be bound by these terms and conditions as long as you hold this username and failure to do so may result in severe consequences.
EOT
	$files{'ThemesList.txt'} = <<"EOT";
winter|1
EOT
	$files{'Smilies.html'} = <<"EOT";
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<blah v="$char">">
<title><blah v="$title"></title>
<link rel="stylesheet" type="text/css" href="<blah v="$templatesu">/<blah v="$dtheme">/template.css">
</head>

<body class="mainbg" bgcolor="#d4d7df" topmargin="5" leftmargin="5" rightmargin="5" bottommargin="5">


<table cellpadding="3" cellspacing="0" width="100%">
 <tr>
  <td><br><blah main></td>
 </tr>
</table><br><font size="1"><center><p><blah v="$copyright"></p></center><br></font>
</body>
</html>
EOT

	# Boards DIR
	$files{'bdindex.db'} = <<"EOT";
cc/Talk about anything that you would like.//Chit - Chat/guest,validating,member/member,guest,validating/////guest,member,validating/////validating,guest,member
EOT
	$files{'bdscats.db'} = <<"EOT";
General Boards|gen|member,guest,validating|cc
EOT

	# Members DIR
	$files{'admin.dat'} = <<"EOT";
$FORM{'pw'}
$FORM{'screenname'}
$email
0










$time
0

0




0





$time


EOT
	$files{'LastMem.txt'} = <<"EOT";
admin
1
EOT
	$files{'List.txt'} = "admin";
	$files{'List2.txt'} = "admin|$FORM{'screenname'}|0|$time||$email|";
	$files{'.htaccess'} = "deny from all\n";
}
1;